#include "GPMTanyaAttack.h"

#ifdef _DXLIB
#include "GStaticDataDX.h"
#else
#include "GStaticData.h"
#endif

using namespace GEnum;

GPMTanyaAttack::GPMTanyaAttack(){
}
GPMTanyaAttack::~GPMTanyaAttack(){
}

void GPMTanyaAttack::setup( HPLShootingObject* lpObject ) {
	this->m_State = *lpObject->getState();
	this->m_nWeaponType = lpObject->getUsingWeaponTypeIndex();

	bool bIsPlayer = lpObject->getObjectType() == ObjectType::PLAYER;
	this->m_bIsHeavyWeapon = false;

	this->m_lpSequence = getStaticData()->m_CommonWork.getSequenceFromObject( lpObject );

	this->m_SequenceState = this->m_lpSequence->getState();

}


void GPMTanyaAttack::attack( HPLShootingObject* lpObject, HPLShootingObject* lpTarget,
	HPLVector* lpCenter, HPLVector* lpVelocityAngle, 
	std::vector<bool>& vecCurrentKeyState, std::vector<bool>& vecPreviousKeyState )
{
	// セットアップ
	this->setup( lpObject );

	int nFaceDirection = ( lpObject->getFaceDirection() > 0 ? 1: -1 );
	// 
	if( this->m_State.isAttackGunState() ) {

		if( this->m_SequenceState.isFinishAnimation ) {
			
			// シーケンスリセット
			/*this->m_lpSequence->resetCounter();

			if( vecCurrentKeyState[ GEnum::KeyMap::B ] &&
				true )//this->m_nWeaponType == GEnum::WeaponType::Evigen::MINIGUN )
			{
				// 押しっぱなし
				// ステートそのまま
			} else {*/

				// ステート巻き戻し
				getStaticData()->m_CommonWork.rollBack( lpObject );
			//}
		}
	} else if( this->m_State.isAttackState() ) {

		if( this->m_State.getState() == StateType::ATTACK ) {
			if( this->m_lpSequence->getFrameIndex() == 1 &&
				this->m_lpSequence->getStepCounter() == 0 )
			{
				// バールで攻撃


				// 攻撃発生
				HPLVector vecShotCenter = lpObject->getCenter();
				vecShotCenter.add( ( lpObject->getFaceDirection() > 0 ? 1: -1 ) * 20, 0 );
				GShot* lpShot = getStaticData()->m_ObjectManager.m_ShotManager.create(
					ShotType::ONLY_SLASH, vecShotCenter, lpObject->getID(), lpObject->getFaceDirection() );
				lpShot->setVelocityAngle( 0, 0 );
			}
		}
		// 攻撃ステート
		if( this->m_SequenceState.isFinishAnimation ) {
			if( this->m_State.getState() == StateType::ATTACK_2 ) {
				HPLVector vCenter = lpObject->getCenter();
				vCenter.add( ( lpObject->getFaceDirection() > 0 ? 1: -1 ) * 20, 0 );
				// 召喚
				int nType = PlayerType::FOBOKO_P;
				GEffect* lpEffect = getStaticData()->m_CommonWork.createEffect(
					Sequence::Effect::CONSTRUCT,
					vCenter,
					vCenter,
					nType, ((GPlayer*)lpObject)->m_nForceID );
			}
			// ステート巻き戻し
			getStaticData()->m_CommonWork.rollBack( lpObject );
		}
	} else {
		// 通常状態

		if( lpObject->getState()->isReadyToAttackState() ) {
			// 攻撃可能な状態

			if( vecCurrentKeyState[ GEnum::KeyMap::A ] &&
				vecPreviousKeyState[ GEnum::KeyMap::A] == false) 
			{
				// バール
				getStaticData()->m_CommonWork.changeState( lpObject, StateType::ATTACK );
				
				// SwordSlash+衝撃波生成
			} else if( vecCurrentKeyState[ GEnum::KeyMap::B ] ) {
				// 召喚				
				getStaticData()->m_CommonWork.changeState( lpObject, StateType::ATTACK_2 );

			} else if( vecCurrentKeyState[ GEnum::KeyMap::C ] ) {
				// 
				//getStaticData()->m_CommonWork.changeState( lpObject, StateType::ATTACK_2 );
			}
		}
	}
}
